/*
    This is a simple application that demonstrates how to use the ZLoad DLL entrypoints.
	It is written
*/
#include <windows.h>
#include <ctype.h>
#include <stdlib.h>
#include <commctrl.h>
#include "ZLoadSample.h"
#include "../zxcomm.h"

// uncomment this line to use the "window handle" API, otherwise the "callback" API will be used
//#define USE_HWND_IFC

// Global Variables:
HINSTANCE hInst;
char *szTitle = "ZLoad DLL Sample";
char *szWindowClass = "ZLoadSample";
HWND hWndMain;
UINT progressMsg = 0;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void                CenterWindow(HWND hWnd, BOOL repaint);
void				processCmdLine(char *cmdLine);

int APIENTRY
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	InitCommonControls();

	// Initialize global strings
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_ZLOADSAMPLE);

	processCmdLine(lpCmdLine);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_ZLOADSAMPLE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_ZLOADSAMPLE;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
#define PB_HEIGHT	30
#define PB_WIDTH	300
#define CAP_HEIGHT	15

	HWND hWnd, hWndCtrl;
	
	hInst = hInstance; // Store instance handle in our global variable

	hWnd = hWndMain = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
			CW_USEDEFAULT, 0, 400, 200, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	   return FALSE;

	RECT r;
	GetClientRect(hWnd, &r);
	int y = (r.bottom - PB_HEIGHT) / 2;

	// create some controls
	hWndCtrl = CreateWindow(PROGRESS_CLASS, NULL, WS_CHILD | WS_VISIBLE | PBS_SMOOTH,
			(r.right - PB_WIDTH) / 2, y, PB_WIDTH, PB_HEIGHT,
			hWnd, (HMENU)IDD_PROGRESS, hInstance, NULL);

	hWndCtrl = CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE | PBS_SMOOTH,
			0, y + PB_HEIGHT + 2, r.right, CAP_HEIGHT, hWnd, (HMENU)IDD_MESSAGE, hInstance, NULL);

	y = (y - CAP_HEIGHT) / 2;
	hWndCtrl = CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE | PBS_SMOOTH,
			0, y, r.right, CAP_HEIGHT, hWnd, (HMENU)IDD_CAPTION, hInstance, NULL);
	y += CAP_HEIGHT + 2;

	hWndCtrl = CreateWindow("STATIC", "", WS_CHILD | WS_VISIBLE | PBS_SMOOTH,
			0, y, r.right, CAP_HEIGHT, hWnd, (HMENU)IDD_FILE, hInstance, NULL);

	CenterWindow(hWnd, FALSE);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK
WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
			case IDM_ABOUT:
			   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			   break;
			case IDM_EXIT:
			   DestroyWindow(hWnd);
			   break;
			default:
			   return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		RECT rt;
		GetClientRect(hWnd, &rt);
		EndPaint(hWnd, &ps);
		break;

	case WM_CTLCOLORSTATIC:
		return((LRESULT)GetStockObject(WHITE_BRUSH));
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	default:
		if (progressMsg && (message == progressMsg))
		{
			// received a progress update message, forward it on to the progress bar control
			SendMessage(GetDlgItem(hWnd, IDD_PROGRESS), PBM_SETPOS, wParam, 0);
			return(1);
		}
		else
			return DefWindowProc(hWnd, message, wParam, lParam);
		break;
	}
	return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
			return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
    return FALSE;
}

// Center a window on its parent (or the desktop).
void
CenterWindow(HWND hWnd, BOOL repaint)
{
	RECT rect;
	RECT dlgRect;
	RECT dsktpRect;
	int  x,y;
	int  dlgWidth;
	int  dlgHeight;

	if (IsWindow(hWnd))
	{
		HWND hWndParent = GetParent(hWnd);

		dsktpRect.left   = dsktpRect.top = 0;
		dsktpRect.right  = GetSystemMetrics(SM_CXFULLSCREEN);
		dsktpRect.bottom = GetSystemMetrics(SM_CYFULLSCREEN);

		if (hWndParent)
			GetWindowRect(hWndParent, &rect);
		else
			rect = dsktpRect;

		GetWindowRect(hWnd, &dlgRect);
		dlgWidth  = dlgRect.right  - dlgRect.left;
		dlgHeight = dlgRect.bottom - dlgRect.top;

		x = ((rect.right - rect.left) / 2) - (dlgWidth / 2);
		y = ((rect.bottom - rect.top) / 2) - (dlgHeight / 2);
		if ((GetWindowLong(hWnd, GWL_STYLE) & WS_CHILD) == 0)
			x += rect.left, y += rect.top;
		if (x < 0)
			x = 0;
		if (y < 0)
			y = 0;

		if ((x + dlgWidth) > dsktpRect.right)
			x = dsktpRect.right - dlgWidth;
		if ((y + dlgHeight) > dsktpRect.bottom)
			y = dsktpRect.bottom - dlgHeight;

		x = max(x, 0);
		y = max(y, 0);

		MoveWindow(hWnd, x, y, dlgWidth, dlgHeight, repaint);
	}
}

// These are the callback functions used by ZLoad DLL routines.  The first one displays
// a message in a static text control.  The second one updates the position of a
// progress bar control.
void APIENTRY
MessageCB(const char *mesg, long mesgData)
{
	if (mesg == NULL)
		mesg = "";
	SendDlgItemMessage(hWndMain, IDD_MESSAGE, WM_SETTEXT, 0, (LPARAM)mesg);
}

WORD APIENTRY
ProgressCB(long recNum, long recCnt, long retryCnt, long progData)
{
	// compute the percentage complete
	WPARAM pct = (recNum * 100 + 50) / recCnt;

	// send the message to update the progress bar position
	SendDlgItemMessage(hWndMain, IDD_PROGRESS, PBM_SETPOS, pct, 0);

	// returning non-zero will tell the downloader to continue the process
	return(1);
}

/*
 ** processCommandLine
 *
 * This code process the command line and, depending on its content, interacts with the ZX.
 * The command line is expected to contain options and a filename.  The named file is downloaded
 * if it has a .zxb extension.  If it has a .zvm extension it is used to perform a Firmware update.
 *
 * The only supported option is -c<portNum> where <portNum> is a decimal value giving the COM port
 * to use.  The COM port must not be in use by another application, of course.
 *
 */
void
processCmdLine(char *cmdLine)
{
	// process the command line, determine what to do
	int port = 1;
	char *p, *file = NULL;
	char *caption = "";
	char buf[200];

	if ((p = cmdLine) != NULL)
	{
		char c;
		
		while ((p != NULL) && ((c = *p) != '\0'))
		{
			if (isspace(c))
				p++;
			else if (c == '-')
			{
				switch(p[1])
				{
				case 'c':		// COM port designator
					port = atoi(p + 2);
					p = strchr(p, ' ');
					break;

				default:
					wsprintf(buf, "Unrecognized option: -%c", c);
					SendDlgItemMessage(hWndMain, IDD_MESSAGE, WM_SETTEXT, 0, (LPARAM)buf);
					p = NULL;
					break;
				}
			}
			else
			{
				// assume it's a file name
				file = p;

				// remove quotes if present
				if (*file == '"')
				{
					file++;
					if ((p = strchr(file, '"')) != NULL)
						// remove the closing quote
						*p++ = '\0';
					else
						// missing closing quote, use remainder of the string
						p = file + strlen(file);
				}
				else
				{
					while ((c = *p) != '\0')
					{
						p++;
						if (isspace(c))
						{
							p[-1] = '\0';
							break;
						}
					}
				}
			}
		}
	}

	if ((port < 1) || (port > 99))
	{
		wsprintf(buf, "Invalid COM port: %u.", port);
		SendDlgItemMessage(hWndMain, IDD_MESSAGE, WM_SETTEXT, 0, (LPARAM)buf);
	}
	else if (file == NULL)
		SendDlgItemMessage(hWndMain, IDD_MESSAGE, WM_SETTEXT, 0, (LPARAM)"Nothing to do.");
	else
	{
		int stat;
		SendDlgItemMessage(hWndMain, IDD_FILE, WM_SETTEXT, 0, (LPARAM)file);

		// determine what to do based on the file's extension
		p = strrchr(file, '.');
		if (p == NULL)
			p = "";
		if (stricmp(p, ".zxb") == 0)
		{
			long flags = ZX_DOWNLOAD_WRITE /*| ZX_DOWNLOAD_VERIFY*/;
			SendDlgItemMessage(hWndMain, IDD_CAPTION, WM_SETTEXT, 0, (LPARAM)"Downloading");
#ifdef USE_HWND_IFC
			// register a message to use for the progress updating
#if 0
			// Send messages via the main window - see WndProc() below for the code that relays the messages to the progress bar
			progressMsg = RegisterWindowMessage("ZXDownloadProgress");
			stat = ZXDownloadWnd(file, port, flags, hWndMain, progressMsg, 0);
#else
			// Interact directly with the progress bar control - note that the extra flag value is added to
			// cause the value returned from the control to be ignored.
			stat = ZXDownloadWnd(file, port, flags | ZX_IGNORE_HWND_RET, GetDlgItem(hWndMain, IDD_PROGRESS), PBM_SETPOS, 0);
#endif
			if (stat == ZX_SUCCESS)
				strcpy(buf, "Download completed successfully.");
			else
				wsprintf(buf, "Download returned error code %u.", stat);
			SendDlgItemMessage(hWndMain, IDD_MESSAGE, WM_SETTEXT, 0, (LPARAM)buf);
#else
			// use a callback
			stat = ZXDownloadEx(file, port, flags, ProgressCB, 0, MessageCB, 0);
#endif
		}
		else if (stricmp(p, ".zvm") == 0)
		{
			SendDlgItemMessage(hWndMain, IDD_CAPTION, WM_SETTEXT, 0, (LPARAM)"Updating Firmware");
			stat = ZXUpdateEx(file, port, ZX_UPDATE_NORMAL, ProgressCB, 0, MessageCB, 0);
		}
		else
			SendDlgItemMessage(hWndMain, IDD_MESSAGE, WM_SETTEXT, 0, (LPARAM)"Unrecognized file type.");
	}
}


